<?php

namespace App\Exceptions;

use App\Exceptions\Pouzivatel\PouzivatelJeBlokovany;
use App\Providers\RouteServiceProvider;
use Illuminate\Auth\Access\AuthorizationException;
use Illuminate\Auth\AuthenticationException;
use Illuminate\Foundation\Exceptions\Handler as ExceptionHandler;
use Illuminate\Session\TokenMismatchException;
use Spatie\Permission\Exceptions\UnauthorizedException;
use Symfony\Component\HttpFoundation\Response;
use Throwable;

/**
 * Class Handler
 */
class Handler extends ExceptionHandler
{
    /**
     * A list of the exception types that are not reported.
     *
     * @var array
     */
    protected $dontReport = [
        //
    ];

    /**
     * A list of the inputs that are never flashed for validation exceptions.
     *
     * @var array
     */
    protected $dontFlash = [
        'current_password',
        'password',
        'password_confirmation',
    ];

    /**
     * Report or log an exception.
     *
     *
     * @return void
     *
     * @throws \Exception|\Throwable
     */
    public function report(Throwable $exception)
    {
        parent::report($exception);
    }

    /**
     * Render an exception into an HTTP response.
     *
     * @param  \Illuminate\Http\Request  $request
     *
     * @throws \Throwable
     */
    public function render($request, Throwable $exception): Response
    {
        if (
            $exception instanceof AuthorizationException
            || $exception instanceof AuthenticationException
            || $exception instanceof PouzivatelJeBlokovany
            || $exception instanceof TokenMismatchException
        ) {
            if ($request->expectsJson()) {
                return response()->json(['error' => 'Unauthorized.'], 403);
            }

            flash()->warning($exception->getMessage())->important();

            return redirect()->guest(route('login.form'));
        }

        if ($exception instanceof UnauthorizedException) {
            if ($request->expectsJson()) {
                return response()->json(['error' => 'Unauthorized.'], 403);
            }

            flash()->warning('Používateľ nemá požadované oprávnenie.')->overlay(null, 'Upozornenie');

            return redirect()->to(RouteServiceProvider::HOME);
        }

        return parent::render($request, $exception);
    }
}
